//
// GVFile
//
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>
#include "GVFile.h"


bool GVFile::open(QString name)
{
  m_start_offset = 0;
  m_fp = fopen(name.data(), "r");
  if ( m_fp != 0 )
    { 
      char buffer[SIZE_BUFFER];
      if ( fgets(buffer, SIZE_BUFFER, m_fp) != 0 )
	{
	  m_start_offset = strlen(buffer);
	  if ( m_start_offset >= 1 )
	    buffer[m_start_offset-1] = '\0';
	  m_start_pos = buffer;
	}
      return true;
    }
  else return false;
}

unsigned int GVFile::getNumRecords()
{
  off_t offset = m_start_offset;

  offset = lseek(fileno(m_fp), 0, SEEK_END);
  
  return ( offset - m_start_offset ) / REC_SIZE;
} 

bool GVFile::getRecord(unsigned int no, NodeRecord& rec)
{
  off_t offset = m_start_offset + no * REC_SIZE;
  
  if ( lseek(fileno(m_fp), offset, SEEK_SET) == offset )
    {
      if ( read(fileno(m_fp), &rec, REC_SIZE) == REC_SIZE )
        {
          return true;
        }
    }
  return false;  
}

bool GVFile::getRootRecord(NodeRecord& rec)
{
  return getRecord(getNumRecords()-1, rec);
}

void GVFile::close()
{
  if ( m_fp != 0 )
    fclose(m_fp);
}
