//
// GVFile
//
#include <qstring.h>
#include <stdio.h>

class GVFile
{
 public:

typedef struct {
  unsigned int id;
  unsigned int lc_id;
  unsigned int ps_id;
  short        alpha;
  short        beta;
  short        eval;
  short        move;
  short        bmove;
  short        height;
  short        flags;
  unsigned long long winlink;
} NodeRecord;

  GVFile(QString name) { open(name); }
  QString getId() const { return strID; }
  QString getStartPos() { return m_start_pos; }
  unsigned int getNumRecords();
  bool getRecord(unsigned int no, NodeRecord& rec);
  bool getRootRecord(NodeRecord& rec);
  ~GVFile() { close(); }; 

 private:
  bool open(QString str);
  void close();
  static const int REC_SIZE = sizeof(NodeRecord);
  static const int SIZE_BUFFER = 1024;
  FILE         *m_fp;
  unsigned int  m_start_offset; 
  QString        strID;
  QString        m_start_pos;
};
