//
//
//
#include "GameBoard.h"
#include <qpainter.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qpixmapcache.h>
#include <qsize.h>

GameBoard::GameBoard(QWidget *parent, 
		     const char * name,
                     QString path,
		     QString sboard, 
		     int x_cells, int y_cells,
		     int x_size, int y_size,
		     int x_start, int y_start, 
		     int x_offset, int y_offset )
  : QWidget(parent,name), m_path(path), m_sboard(sboard), 
    m_x_cells(x_cells), m_y_cells(y_cells),
    m_x_size(x_size), m_y_size(y_size),
    m_x_start(x_start), m_y_start(y_start), 
    m_x_offset(x_offset), m_y_offset(y_offset)
{
  QString fname;
  fname.sprintf("%s/%s.png", m_path.latin1(), m_sboard.latin1() );
  m_pm.load(fname);

  this->setFixedWidth(m_pm.width());
}


void GameBoard::paintEvent(QPaintEvent*)
{
    QPainter paint;
    QPixmap pm;
    paint.begin(this);
    paint.drawPixmap( 0,0, m_pm);
    for ( int i=0 ; i<m_y_cells; i++ ) { //
        for ( int j=0 ; j<m_x_cells;j++ ) { //
            if ( m_board[i][j] != '.' ) {
                QString name;
                name.sprintf("%s/%c.png", m_path.latin1(), m_board[i][j] );
                if ( !QPixmapCache::find(name, pm) ) {
                    pm.load(name);
                    QPixmapCache::insert(name, pm);
                }
                int x = m_x_start + (m_x_size * j) + (m_x_offset * i);
                int y = m_y_start + (m_y_size * i) + (m_y_offset * j);
                paint.drawPixmap(x, y, pm);
            }
        }
    } 
    paint.end();    
}



void GameBoard::setBoard(QString string) 
{
  const char *str = string.latin1();

  for ( int i=0 ; i<m_y_cells; i++ ) {
    for ( int j=0 ; j<m_x_cells;j++ ) {
      m_board[i][j] = '.';
    }
  } 

  unsigned int n=0;
  for ( int i=0 ; i<m_y_cells ; i++ ) {
      for ( int j=0 ; j<m_x_cells ; j++ ) {
          if ( n < strlen(str) ) {
              if ( str[n] != '.' ) {
                  if ( str[n] == ' ' ) break;
                  m_board[i][j] = str[n]; 
              }
              n++;
          }
      } 
  } 
  
  update();
}
