//
// GameTreeView.h
//
#ifndef GAME_TREE_VIEW_H
#define GAME_TREE_VIEW_H

#include <qlistview.h>
#include "GVFile.h"

class GameTreeView;

class GameTreeViewItem : public QListViewItem
{
 public:
  GVFile  *m_gvf;
  GVFile::NodeRecord m_rec;
  
 public:
  GameTreeViewItem( QListView *parent, GVFile *gvf, 
		    const GVFile::NodeRecord &rec);
  GameTreeViewItem( GameTreeViewItem *parent, GVFile *gvf,
		    const GVFile::NodeRecord &rec);

  void setOpen( bool visible );
  int  getMoves(unsigned int moves[]);
  void getBoard( QString& str);

 private:
  void setRecord(const GVFile::NodeRecord& rec);
};


class GameTreeView : public QWidget
{
  Q_OBJECT

public:
  GameTreeView(QWidget *parent  = 0, const char *name = 0, 
	       QString config = 0, bool sdo = false);
 ~GameTreeView();
 
 bool openFile(QString filename);

 signals:
 void currentChanged(QString str);
    
 private slots:
   void currentItemChanged( QListViewItem* );

 private:
 GVFile *pGVF;
 QListView *lv;
 void *handle;
 QString config;

};

#endif
