#include "config.h"

Config::Config(ifstream& strm)
{
  string tag, assign, value;
 
  while ( strm >> tag ) {
    strm >> assign;
    if ( assign != "=" ) {
      cerr  <<  "Corrupted config file" << endl;
      exit(1);
    }
    strm >> value;
    m_tags[tag] = value;
  }
}

bool Config::getValue(const string& tag, string& value)
{
  map<string,string>::iterator it = m_tags.find(tag);

  if ( it != m_tags.end() ) {
    value = it->second;
    return true;
  }
  
  return false;
}


/*
int main()
{
  ifstream inStream;

  inStream.open("checkers.cfg");
  if ( inStream ) {
    Config cfg(inStream);
    string value;

    cout << "BOARD_BACKGROUND = ";
    if ( cfg.getValue("BOARD_BACKGROUND",value) )
      cout << value;
    cout << endl;

    cout << "BOARD_X_SIZE = ";
    if ( cfg.getValue("BOARD_X_SIZE",value) )
      cout << value;
    cout << endl;

    inStream.close();
  }
} 
*/
