#ifndef INCLUDE_GTF
#define INCLUDE_GTF
extern "C" {
#include <stdio.h>
}


typedef struct {
  NodeRecord  rec;
  int         cno;
} GTFStack;

typedef struct {
  GTFStack*   stack;
  int         d;
  FILE       *fp;
  int         id;
} GTF;


GTF* gtf_New(int max_depth);

void  gtf_Free( GTF *pGTF );

void gtf_Start( GTF *pGTF, FILE *fp, const char* start_str );

void gtf_Stop( GTF *pGTF );

void gtf_NodeEnter(GTF *pGTF, int move, short alpha, short beta);

void gtf_NodeExit(GTF *pGTF, int bmove, short eval, short height, short flags,
                  unsigned long long winlink );
#endif
